'use strict';

var ramda = require('ramda');

//

// 

const createResult = (value, messages = []) => ({value, messages});

const createAlwaysValidResult = (value) => createResult(value);

// 


const shouldRuleBeInvoked = ramda.curry((rule, value) => {
  // TODO: This function is provisionaly naive implementation.
  if (rule.required && value === rule.defaultValue) {
    // Abort validation if field if field is _not_ required and value _is_ defaultValue
    return false
  }
  return true
});

const runRule = ramda.curry((rule, value) => {
  if (!shouldRuleBeInvoked(rule, value)) {
    return createAlwaysValidResult(value)
  }

  return createResult(value, rule.validations
    // $FlowFixMe: I‘m right, flow wrong in this case.
    .map((validation) => validation(value))
    .filter((maybeMessage) => typeof maybeMessage === 'string'))
});

// 
const movePropertyDeeperIntoObject = (deeperName, shape) => ramda.map((v) => ({[deeperName]: v}), shape);

const mergeRulesAndValues = (rs, vs) => ramda.mergeDeepLeft(
  movePropertyDeeperIntoObject('rule', rs),
  movePropertyDeeperIntoObject('value', vs)
);

// TODO: Add third paramters - settings.
const validate$1 = (rules, values$$1) => ramda.values(
  ramda.mapObjIndexed(
    (v, k) => ({name: k, rule: v.rule, value: v.value}),
    mergeRulesAndValues(rules, values$$1)
  ))
  .reduce(
    (results, {name, rule, value}) => Object.assign({}, results, {[name]: runRule(rule, value)}),
    {}
  );

var validate$2 = ramda.curry(validate$1);

module.exports = validate$2;
